/*
 iA6 Receiver - RSSI PWM output
 Version: 1.0
 Author: Alex from insideGadgets (http://www.insidegadgets.com)
 Created: 24/11/2015
 Last Modified: 24/11/2015
  
 */
 
#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif

#define LOW 0
#define HIGH 1
#define false 0
#define true 1

// Setup the ATtiny
void setup(void) {
	
	// Set outputs
	DDRB |= (1<<rssiPWMout);
	
	// Turn on pull-up resistors on other ports to save power
	PORTB |= (1<<PB3) | (1<<PB1); 
	
	// Setup timers for RSSI 50Hz PWM output
	TIMSK = (1<<OCIE0A) | (1<<TOIE1) | (1<<OCIE1A);
	OCR1A = 150; // Pulse start (~100us resolution)
	OCR1C = 158; // Overflow timer for timer end and hand over to timer 0
	TCCR1 = (1<<CTC1) | (1<<PWM1A) | (1<<CS13) | (1<<CS12); // CTC
	
	OCR0A = 1; // Pulse end (minimum of 1), (~4us resolution)
	TCCR0A = (1<<WGM01); // CTC for 1ms
	
	sei(); // Turn on interrupts
}
